/*
 * 
 * Librairie de gestion de la RTC DS3231
 * 
 */

byte bcdToDec(byte val)  {
// Convert binary coded decimal to normal decimal numbers
  return ( (val/16*10) + (val%16) );
}

byte decToBcd(byte val)
{
  return( (val/10*16) + (val%10) );
}

void setDS3231time(byte seconds, byte minutes, byte hours, byte dayOfWeek, byte
dayOfMonth, byte months, byte years)
{
  // sets time and date data to DS3231
  Wire.beginTransmission(DS3231_ADDRESS);
  Wire.write(0); // set next input to start at the seconds register
  Wire.write(decToBcd(seconds)); // set seconds
  Wire.write(decToBcd(minutes)); // set minutes
  Wire.write(decToBcd(hours)); // set hours
  Wire.write(decToBcd(dayOfWeek)); // set day of week (1=Sunday, 7=Saturday)
  Wire.write(decToBcd(dayOfMonth)); // set date (1 to 31)
  Wire.write(decToBcd(months)); // set month
  Wire.write(decToBcd(years)); // set year (0 to 99)
  Wire.endTransmission();
}

void printDate()
{
  // Reset the register pointer
  Wire.beginTransmission(DS3231_ADDRESS);
  Wire.write(0);
  Wire.endTransmission();
  Wire.requestFrom(DS3231_ADDRESS, 7);
  second = bcdToDec(Wire.read());
  minute = bcdToDec(Wire.read());
  hour = bcdToDec(Wire.read() & 0b111111); //24 hour time
  weekDay = bcdToDec(Wire.read()); //0-6 -> sunday - Saturday
  monthDay = bcdToDec(Wire.read());
  month = bcdToDec(Wire.read());
  year = bcdToDec(Wire.read());
}

int printtemp()
{
    int rv;    
    uint8_t temp_msb, temp_lsb;
    int8_t nint;
    Wire.beginTransmission(DS3231_ADDRESS);
    Wire.write(DS3231_TEMPERATURE_ADDR);
    Wire.endTransmission();
    Wire.requestFrom(DS3231_ADDRESS, 2);
    temp_msb = Wire.read();
    temp_lsb = Wire.read() >> 6;
    if ((temp_msb & 0x80) != 0)
        nint = temp_msb | ~((1 << 8) - 1);      // if negative get two's complement
    else
        nint = temp_msb;
    rv = 10*(0.25 * temp_lsb + nint);
    return rv;
}

