#
# Programme de convertion d'une image BMP de 128x16 pixels - 16 couleurs
# en 4 niveaux de gris, 2 bits par pixels sur deux pages (vers un fichier Txt pour la carte SD)
# Par Aganyte Janvier 2017
# Version 0.1
#

import sys

#Message d'acceuil
print("Bmp2Anim v0.1 by Aganyte")
print("")

#on récupère le nom du fichier à traiter
file = str(sys.argv[1])
print("convertion de "+file)

#Ouverture du fichier de destination
Output = open(file[0:-7]+".txt",'w')

#déterminer quelle(s) image(s) nous allons traiter
image_number = int(file[-7:-4])

flag_start = True

while True:

	#On charge l'image en cours en mémoire
	try:
                if image_number > 99:
                    fichier = open(file[0:-7]+str(image_number)+".bmp",'rb')
                elif image_number > 9:
                    fichier = open(file[0:-7]+"0"+str(image_number)+".bmp",'rb')
                else:
                    fichier = open(file[0:-7]+"00"+str(image_number)+".bmp",'rb')
                if flag_start == False:
                    Output.write("\n")
                flag_start = False
	except:
            Output.write("#")
            print("fichier introuvable ou plus de fichier à traiter")
            print("votre fichier est prêt.")
            Output.close()
            exit()
	Lu = fichier.read()
	fichier.close()

	#on convertit la chaine de caractères en tableau
	Lu = list(Lu)

	#on lit l'addresse de départ de l'image
	Depart = Lu[0x0A]
	print("adresse de depart =",Depart)

	#On supprime tout ce qui ne fait pas partit de l'image (si tout va bien, il y a 1024 adresses)
	del Lu [0:Depart]
	print("l'image fait",len(Lu),"octets")

	#On sépare les deux quartets qui constituent deux pixels (et on les convertit en 4 niveaux de gris), le tout est stocké dans le tableau Ram (si tout va bien, on passe à 2048 adresses)
	Ram=[]
	for x in range (0,len(Lu)):
		Ram.append(int((Lu[x]&0xf0)>>4))
		Ram.append(int(Lu[x]&0x0f))

        # Afficher le quartet dans la console
	Buffer = 0
	Chaine = ""
	for x in range (0,len(Ram)):
		Chaine += (str(Ram[x]))
		Buffer += 1
		if Buffer == 128:
			Chaine += ("\n")
			Buffer = 0
	print(Chaine)       

	#On sépare Ram en deux tableaux de 1 bits par pixels (Image1 et Image2) de 1024 adresses chacun
	Image1=[]
	Image2=[]
	for x in range (0,len(Ram)):
		if (Ram[x] == 3) | (Ram[x] == 1):
			Image1.append(1)
		else:
			Image1.append(0)
		if (Ram[x] == 3) | (Ram[x] == 2):
			Image2.append(1)
		else:
			Image2.append(0)

	#On convertit Image1 et Image2 (qui sont en binaire) en deux tableaux Image1octet et Image2octet (qui contiennent des octets)
	Image1octet=[]
	Image2octet=[]

	Buffer = 0 # Traitement de Image1octet
	for x in range (0,int((len(Image1)/8))):
		if Image1[x*8] == 1:
			Buffer = 128
		if Image1[(x*8)+1] == 1:
			Buffer += 64
		if Image1[(x*8)+2] == 1:
			Buffer += 32
		if Image1[(x*8)+3] == 1:
			Buffer += 16
		if Image1[(x*8)+4] == 1:
			Buffer += 8
		if Image1[(x*8)+5] == 1:
			Buffer += 4
		if Image1[(x*8)+6] == 1:
			Buffer += 2
		if Image1[(x*8)+7] == 1:
			Buffer += 1
		Image1octet.append(Buffer)
		Buffer = 0

	Buffer = 0 # Traitement de Image2octet
	for x in range (0,int((len(Image2)/8))):
		if Image2[x*8] == 1:
			Buffer = 128
		if Image2[(x*8)+1] == 1:
			Buffer += 64
		if Image2[(x*8)+2] == 1:
			Buffer += 32
		if Image2[(x*8)+3] == 1:
			Buffer += 16
		if Image2[(x*8)+4] == 1:
			Buffer += 8
		if Image2[(x*8)+5] == 1:
			Buffer += 4
		if Image2[(x*8)+6] == 1:
			Buffer += 2
		if Image2[(x*8)+7] == 1:
			Buffer += 1
		Image2octet.append(Buffer)
		Buffer = 0

	#On écrit la première partie de l'image
	Buffer = 0
	ligne = 0
	for x in range (0,len(Image1octet)):
		Output.write("%0.2X" % Image1octet[x])
		Buffer += 1
		if Buffer == 16:
			Output.write("\n")
			Buffer = 0
			ligne += 1
			if ligne == 16:
                                Output.write("\n")
                                ligne=0
	#puis la deuxième 
	for x in range (0,len(Image2octet)):
		Output.write("%0.2X" % Image2octet[x])
		Buffer += 1
		if Buffer == 16:
			Output.write("\n")
			Buffer = 0
			ligne += 1
			#if ligne == 16:
                        #        Output.write("\n")
                        #        ligne=0
        
	#On passe au fichier suivant
	print("image "+str(image_number)+" traitée")
	print("")
	image_number+=1
