/*
 * FICHIER DE CONFIGURATION
 * pour la librairie de gestion d'un DOT de 128 x 16 Pixels - V0.5
 * Par Christophe Girardot Aka Aganyte - Novembre 2017 
 */

/* Définition des entrées/sorties sur l'Arduino */
byte LATCH = 8;                                           // latch, actif sur front montant
byte E = 2;                                               // Output enable, actif à l'état bas
byte A = 4;                                               // Port de communication des lignes 
byte B = 5;                                               // Port de communication des lignes 
byte C = 6;                                               // Port de communication des lignes 
byte D = 7;                                               // Port de communication des lignes 

/* Réglages de l'affichage */
unsigned char Clock_Second = 3;                           // Temps d'affichage de l'heure en secondes
unsigned char Temp_Second = 2;                            // Temps d'affichage de la température en secondes
#define separator_speed         500                       // Vitesse de clignotement du séparateur heures/minutes en millisecondes
#define Scrolling_speed_time    500                       // Vitesse de déplacement d'un caractère en scrolling horizontal en millisecondes
#define Brightness              200                       // Ajustage du temps d'allumage d'une led à fond en microsecond (pour le mode monochrome)

/* Réglages de l'image pour les animations, scrolling et images en "4 niveaux de gris" */
#define full_led_contrast       300                       // Ajustage du temps d'allumage d'une led à fond en microsecond (attention : à régler avec une mire)
#define dark_grey_led_contrast  200                       // Ajustage du temps d'allumage d'une led à moitié en microsecond (attention : à régler avec une mire)
#define light_grey_led_contrast 2                         // Ajustage du temps d'allumage d'une led au mini en microsecond (attention : à régler avec une mire)
#define slow_animation_speed    10                        // Valeur qui ralentit la vitesse de lecture des animations
#define slow_scrolling_speed    10                        // Valeur qui ralentit la vitesse de lecture d'un scrolling
bool read_just_SD = false;                                // Permet de lire seulement les animations de la carte SD (true or false)

/* Réglages de l'image pour les animations de transition */
bool transition_enable = true;                            // Activer les transitions (true or false)
#define Transition_frame_time 50                          // Ajustage de la durée d'une frame pour les animations de transition (en millisecondes)

/* Réglages hardware */
#define Dot_SPI_speed               10000000              // Vitesse de la liaison SPI vers le dot en Hertz
SPISettings settings(Dot_SPI_speed, LSBFIRST, SPI_MODE0); // Réglage de la liaison SPI pour le DOT
#define DS3231_ADDRESS              0x68                  // Adresse I2C pour l'heure
#define DS3231_TEMPERATURE_ADDR     0x11                  // Adresse I2C pour la température
#define SD_folder                   "/"                   // Dossier de stockage des animations sur la carte SD

/* VARIABLES GLOBALES */
int second, minute, hour, weekDay, monthDay, month, year; // Variable globales pour la gestion de l'heure
unsigned char Display_Ram[256];                           // 256 octets de mémoire vidéo */
unsigned char Shade1_Display_Ram[256];                    // 256 octets de mémoire vidéo de niveau 1 */
unsigned char Shade2_Display_Ram[256];                    // 256 octets de mémoire vidéo de niveau 2 */
unsigned char Animation_Ram[65535];                       // 65 Ko d'Animation Buffer (Grand Papa Mémoire !!) */
unsigned char flag_temp_clock = false;                    // Drapeau pour la fonction alternance horloge/temperature */
bool SD_ready = false;                                    // Drapeau de test de la carte SD (initialisé à "0" car carte supposée absente à la mise en route, ne pas modifier)
bool SD_I_have_seen_everything = false;                   // Drapeau qui indique si l'on a vu toutes les animations de la SD (initialisé à "0" car, au démarrage, on a rien vu !!)
File root;                                                // Objet pour la gestion du dossier de lecture dans la carte SD
File myFile;                                              // Objet pour la gestion du fichier à lire dans la carte SD

